<template>
  <div class="contenedor-login">
    <v-row justify="center">
      <v-col cols="12" sm="10" md="8" lg="6">
        
        <v-card ref="form">
         
          <v-card-text>
            <v-text-field
              ref="email"
              v-model="email"
              label="Correo Electronico"
              placeholder="Correo"
              counter="25"
              required
            ></v-text-field>
            <v-text-field
              v-model="password"
              :append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
              :type="show1 ? 'text' : 'password'"
              name="input-10-1"
              label="Contraseña"
              hint="Tu contraseña cumple con los 8 caracteres"
              counter
              @click:append="show1 = !show1"
            ></v-text-field>
            <!-- <v-img src="https://drive.google.com/file/d/1hwuc14ibSq9fxCP9D7_wVQdMR619oNXn/view?usp=sharing" aspect-ratio="0.5"></v-img> -->
          </v-card-text>
          <v-divider class="mt-12"></v-divider>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-slide-x-reverse-transition>
              <v-tooltip
                v-if="formHasErrors"
                left
              >
              <template>
                  <!-- Aqui va el logo -->
              </template>
                <template v-slot:activator="{ on }">
                  <v-btn
                    icon
                    class="my-0"
                    @click="resetForm"
                    v-on="on"
                  >
                    <v-icon>mdi-refresh</v-icon>
                  </v-btn>
                </template>
                <span>Refresh form</span>
              </v-tooltip>
            </v-slide-x-reverse-transition>
            <v-btn color="primary" text @click="submit">Login </v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
  </div>
</template>


<script>
  import "firebase/auth";
  import firebase from "firebase/app";
  import 'firebase/firestore';
  export default {
    async created(){
      firebase.auth().onAuthStateChanged(async () =>{
        const userData = await firebase.auth().currentUser.getIdTokenResult()
        const rol = userData.claims.role
        
        if(rol == 'Administrador' || rol == 'Agente'){
          this.loggedIn = true
          this.$emit('login', true)  
        }
        else{
          await firebase.auth().signOut();
        }
      })
    },
    data: () => ({
      email:null,
      password:null,
      loggedIn: false
    }),

    computed: {
      form () {
        return {
          email: this.email,
          password: this.password,
        }
      },
    },

    watch: {
      name () {
        this.errorMessages = ''
      },
    },

    methods: {
      addressCheck () {
        this.errorMessages = this.address
          ? 'Hey! I\'m required'
          : ''

        return true
      },
      resetForm () {
        this.errorMessages = []
        this.formHasErrors = false

        Object.keys(this.form).forEach(f => {
          this.$refs[f].reset()
        })
      },
      async submit () {
        await firebase.auth().signInWithEmailAndPassword(this.email, this.password)
      },
    },
  }
</script>

<style scoped>
.contenedor-login {
  background: linear-gradient(70deg,#0B2748, #572B53);
  height: 20rem;
}
</style>


